function checkHref(elem) {
  var xmlHttp = new XMLHttpRequest()
  xmlHttp.onreadystatechange = function () {
    if (xmlHttp.readyState == 4) {
      elem.classList.add("hasResponseStatus")
      elem.classList.add("status-" + xmlHttp.status)
      elem.title = "Response code: " + xmlHttp.status + " - " + xmlHttp.statusText
    }
  }
  xmlHttp.open("GET", elem.href, true) // true for asynchronous 
  xmlHttp.send(null)
}

function checkPerms(className) {
  var rootElems = document.getElementsByClassName(className)
  Array.from(rootElems).forEach(elem =>
    Array.from(elem.children).forEach(elem => checkHref(elem))
  )
}

async function get_resource(id, token, authProvider) {
  //if (!keycloak.keycloak) { return }
  const msg = document.getElementById("msg")
  const resourceElem = document.getElementById('resource')
  const resp = await fetch("resource/" + id, {
    method: "GET",
    headers: new Headers({
      "Content-type": "application/json",
      "Authorization": `Bearer ${token}`,
      "auth_provider": authProvider,
    }),
  }).catch(err => {
    msg.innerHTML = "Cannot fetch resource: " + err.message
    resourceElem.innerHTML = ""
  })
  if (resp === undefined) {
    return
  }
  const resource = await resp.json()
  if (!resp.ok) {
    msg.innerHTML = resource["detail"]
    resourceElem.innerHTML = ""
    return
  }
  msg.innerHTML = ""
  resourceElem.innerHTML = ""
  Object.entries(resource).forEach(
    ([k, v]) => {
      let r = document.createElement('div')
      let kElem = document.createElement('div')
      kElem.innerText = k
      kElem.className = "key"
      let vElem = document.createElement('div')
      vElem.innerText = v
      vElem.className = "value"
      if (k == "sorry") {
        vElem.classList.add("error")
      }
      r.appendChild(kElem)
      r.appendChild(vElem)
      resourceElem.appendChild(r)
    }
  )
}
